<?php

namespace Bushelpowered\Api\Platform\Authorization\Event;

class AccountIdentifiersVersions
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'version1' => '\Bushelpowered\Api\Platform\Authorization\V1\Event\AccountIdentifiersRaw',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Version1(\Bushelpowered\Api\Platform\Authorization\V1\Event\AccountIdentifiersRaw $data): AccountIdentifiersVersions
    {
        return new AccountIdentifiersVersions('version1', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    