<?php
namespace Bushelpowered\Api\Platform\File\V1\Common;
        
class File implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    public string $id;
    public \Bushelpowered\Api\Platform\File\V1\Common\FileType $fileType;
    public string $displayName;
    public string $contentType;
    public bool $public;
    public string $sourceFileName;
    public string $sourceContentType;
    public int $size;
    public string $createdBy;
    public \Bushelpowered\Dev\Bidl\Builtins\Presence $url;
    public \Bushelpowered\Dev\Bidl\Builtins\Presence $attachments;
    /** @var string $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, \Bushelpowered\Api\Platform\File\V1\Common\FileType $fileType, string $displayName, string $contentType, bool $public, string $sourceFileName, string $sourceContentType, int $size, string $createdBy, \Bushelpowered\Dev\Bidl\Builtins\Presence $url, \Bushelpowered\Dev\Bidl\Builtins\Presence $attachments, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->fileType = $fileType;
        $this->displayName = $displayName;
        $this->contentType = $contentType;
        $this->public = $public;
        $this->sourceFileName = $sourceFileName;
        $this->sourceContentType = $sourceContentType;
        $this->size = $size;
        $this->createdBy = $createdBy;
        $this->url = $url;
        $this->attachments = $attachments;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}