<?php
namespace Bushelpowered\Api\Platform\File\V1\Request;
        
class GetFilesRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var \Bushelpowered\Api\Platform\File\V1\Common\FileFilter[]|null $filters */
    public ?array $filters = null;
    public ?\Bushelpowered\Api\Platform\File\V1\Common\FilePagination $pagination = null;
    /** @var \Bushelpowered\Api\Platform\File\V1\Request\GetFilesRequestOptions[] $options */
    public array $options;

    /**
     * @param  \Bushelpowered\Api\Platform\File\V1\Common\FileFilter[]|null  $filters 
     * @param  \Bushelpowered\Api\Platform\File\V1\Request\GetFilesRequestOptions[]  $options 
     */
    public function __construct(?array $filters, ?\Bushelpowered\Api\Platform\File\V1\Common\FilePagination $pagination, array $options)
    {
        $this->filters = $filters;
        $this->pagination = $pagination;
        $this->options = $options;
    }
    
    public function getPagination(): ?\Bushelpowered\Api\Platform\File\V1\Common\FilePagination
    {
        return $this->pagination;
    }
}