<?php
namespace Bushelpowered\Api\Platform\File\V1\Request;
        
class StoreFileRequest 
{
    public \Bushelpowered\Api\Platform\File\V1\Common\FileType $fileType;
    public string $displayName;
    public string $sourceFileName;
    public string $sourceContentType;
    public bool $public;
    public string $createdBy;
    /** @var \Bushelpowered\Api\Platform\File\V1\Common\Attachment[]|null $attachments */
    public ?array $attachments = null;
    public ?\Bushelpowered\Api\Platform\File\V1\Common\Validations $validations = null;
    public \Bushelpowered\Api\Platform\File\V1\Common\FileData $data;

    /**
     * @param  \Bushelpowered\Api\Platform\File\V1\Common\Attachment[]|null  $attachments 
     */
    public function __construct(\Bushelpowered\Api\Platform\File\V1\Common\FileType $fileType, string $displayName, string $sourceFileName, string $sourceContentType, bool $public, string $createdBy, ?array $attachments, ?\Bushelpowered\Api\Platform\File\V1\Common\Validations $validations, \Bushelpowered\Api\Platform\File\V1\Common\FileData $data)
    {
        $this->fileType = $fileType;
        $this->displayName = $displayName;
        $this->sourceFileName = $sourceFileName;
        $this->sourceContentType = $sourceContentType;
        $this->public = $public;
        $this->createdBy = $createdBy;
        $this->attachments = $attachments;
        $this->validations = $validations;
        $this->data = $data;
    }
    

}