<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Response;
        
class CompanyResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp, \Bushelpowered\Api\Common\HasDeletedAtTimestamp
{
    public string $id;
    public string $slug;
    public int $cqgCategoryId;
    /** @var null|string $ingestEnabledAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $ingestEnabledAt = null;
    public bool $displayConvertedBasis;
    public string $bidRoundingStrategy;
    public int $cashBidDecimalFormat;
    /** @var string $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var null|string $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;

    /**
     * @param  null|string  $ingestEnabledAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $slug, int $cqgCategoryId, ?string $ingestEnabledAt, bool $displayConvertedBasis, string $bidRoundingStrategy, int $cashBidDecimalFormat, string $createdAt, string $updatedAt, ?string $deletedAt)
    {
        $this->id = $id;
        $this->slug = $slug;
        $this->cqgCategoryId = $cqgCategoryId;
        $this->ingestEnabledAt = $ingestEnabledAt;
        $this->displayConvertedBasis = $displayConvertedBasis;
        $this->bidRoundingStrategy = $bidRoundingStrategy;
        $this->cashBidDecimalFormat = $cashBidDecimalFormat;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return null|string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
}